liblinphone 3.8.1

- Main Page
- Related Pages
- Modules
- Data Structures

Macros | Typedefs | Enumerations | Functions
Placing and receiving calls

## Macros
#define | linphone_call_params_local_conference_mode linphone_call_params_get_local_conference_mode

## Typedefs
typedef enum _LinphoneMediaDirection | LinphoneMediaDirection
typedef struct _LinphoneCallParams | LinphoneCallParams
typedef struct _LinphoneCall | LinphoneCall
typedef enum _LinphonePrivacy | LinphonePrivacy
typedef struct _LinphonePlayer | LinphonePlayer
typedef void(* | LinphonePlayerEofCallback )(struct _LinphonePlayer *obj, void *user_data)
typedef enum _LinphoneCallState | LinphoneCallState

## Enumerations
enum | _LinphoneMediaDirection { , LinphoneMediaDirectionSendOnly, LinphoneMediaDirectionRecvOnly, LinphoneMediaDirectionSendRecv }
enum | _LinphonePrivacy { LinphonePrivacyNone =0x0, LinphonePrivacyUser =0x1, LinphonePrivacyHeader =0x2, LinphonePrivacySession =0x4, LinphonePrivacyId =0x8, LinphonePrivacyCritical =0x10, LinphonePrivacyDefault =0x8000 }
enum | _LinphoneCallState { LinphoneCallIdle, LinphoneCallIncomingReceived, LinphoneCallOutgoingInit, LinphoneCallOutgoingProgress, LinphoneCallOutgoingRinging, LinphoneCallOutgoingEarlyMedia, LinphoneCallConnected, LinphoneCallStreamsRunning, LinphoneCallPausing, LinphoneCallPaused, LinphoneCallResuming, LinphoneCallRefered, LinphoneCallError, LinphoneCallEnd, LinphoneCallPausedByRemote, LinphoneCallUpdatedByRemote, LinphoneCallIncomingEarlyMedia, LinphoneCallUpdating, LinphoneCallReleased }

## Functions
void | linphone_call_params_add_custom_header (LinphoneCallParams *cp, const char *header_name, const char *header_value)
LinphoneCallParams * | linphone_call_params_copy (const LinphoneCallParams *cp)
bool_t | linphone_call_params_early_media_sending_enabled (const LinphoneCallParams *cp)
void | linphone_call_params_enable_early_media_sending (LinphoneCallParams *cp, bool_t enabled)
void | linphone_call_params_enable_low_bandwidth (LinphoneCallParams *cp, bool_t enabled)
void | linphone_call_params_enable_video (LinphoneCallParams *cp, bool_t enabled)
const char * | linphone_call_params_get_custom_header (const LinphoneCallParams *cp, const char *header_name)
bool_t | linphone_call_params_get_local_conference_mode (const LinphoneCallParams *cp)
LinphoneMediaEncryption | linphone_call_params_get_media_encryption (const LinphoneCallParams *cp)
LinphonePrivacyMask | linphone_call_params_get_privacy (const LinphoneCallParams *cp)
float | linphone_call_params_get_received_framerate (const LinphoneCallParams *cp)
MSVideoSize | linphone_call_params_get_received_video_size (const LinphoneCallParams *cp)
const char * | linphone_call_params_get_record_file (const LinphoneCallParams *cp)
const char * | linphone_call_params_get_rtp_profile (const LinphoneCallParams *cp)
float | linphone_call_params_get_sent_framerate (const LinphoneCallParams *cp)
MSVideoSize | linphone_call_params_get_sent_video_size (const LinphoneCallParams *cp)
const char * | linphone_call_params_get_session_name (const LinphoneCallParams *cp)
const LinphonePayloadType * | linphone_call_params_get_used_audio_codec (const LinphoneCallParams *cp)
const LinphonePayloadType * | linphone_call_params_get_used_video_codec (const LinphoneCallParams *cp)
bool_t | linphone_call_params_low_bandwidth_enabled (const LinphoneCallParams *cp)
void | linphone_call_params_set_audio_bandwidth_limit (LinphoneCallParams *cp, int bw)
void | linphone_call_params_set_media_encryption (LinphoneCallParams *cp, LinphoneMediaEncryption enc)
void | linphone_call_params_set_privacy (LinphoneCallParams *params, LinphonePrivacyMask privacy)
void | linphone_call_params_set_record_file (LinphoneCallParams *cp, const char *path)
void | linphone_call_params_set_session_name (LinphoneCallParams *cp, const char *name)
bool_t | linphone_call_params_video_enabled (const LinphoneCallParams *cp)
LinphoneMediaDirection | linphone_call_params_get_audio_direction (const LinphoneCallParams *cp)
LinphoneMediaDirection | linphone_call_params_get_video_direction (const LinphoneCallParams *cp)
void | linphone_call_params_set_audio_direction (LinphoneCallParams *cp, LinphoneMediaDirection dir)
void | linphone_call_params_set_video_direction (LinphoneCallParams *cp, LinphoneMediaDirection dir)
void * | linphone_call_params_get_user_data (const LinphoneCallParams *cp)
void | linphone_call_params_set_user_data (LinphoneCallParams *cp, void *ud)
LinphoneCallParams * | linphone_call_params_ref (LinphoneCallParams *cp)
void | linphone_call_params_unref (LinphoneCallParams *cp)
void | linphone_call_params_destroy (LinphoneCallParams *cp)
bool_t | linphone_call_get_authentication_token_verified (LinphoneCall *call)
void | linphone_call_set_authentication_token_verified (LinphoneCall *call, bool_t verified)
LinphoneCall * | linphone_call_ref (LinphoneCall *obj)
void | linphone_call_unref (LinphoneCall *obj)
const LinphoneCallParams * | linphone_call_get_current_params (LinphoneCall *call)
const LinphoneCallParams * | linphone_call_get_remote_params (LinphoneCall *call)
const LinphoneAddress * | linphone_call_get_remote_address (const LinphoneCall *call)
char * | linphone_call_get_remote_address_as_string (const LinphoneCall *call)
LinphoneCallState | linphone_call_get_state (const LinphoneCall *call)
LinphoneReason | linphone_call_get_reason (const LinphoneCall *call)
const LinphoneErrorInfo * | linphone_call_get_error_info (const LinphoneCall *call)
void * | linphone_call_get_user_data (const LinphoneCall *call)
void | linphone_call_set_user_data (LinphoneCall *call, void *user_pointer)
LinphoneCallLog * | linphone_call_get_call_log (const LinphoneCall *call)
const char * | linphone_call_get_refer_to (const LinphoneCall *call)
LinphoneCall * | linphone_call_get_transferer_call (const LinphoneCall *call)
LinphoneCall * | linphone_call_get_transfer_target_call (const LinphoneCall *call)
LinphoneCallDir | linphone_call_get_dir (const LinphoneCall *call)
const char * | linphone_call_get_remote_user_agent (LinphoneCall *call)
const char * | linphone_call_get_remote_contact (LinphoneCall *call)
bool_t | linphone_call_has_transfer_pending (const LinphoneCall *call)
int | linphone_call_get_duration (const LinphoneCall *call)
LinphoneCall * | linphone_call_get_replaced_call (LinphoneCall *call)
void | linphone_call_enable_camera (LinphoneCall *call, bool_t enable)
void | linphone_call_send_vfu_request (LinphoneCall *call)
int | linphone_call_take_video_snapshot (LinphoneCall *call, const char *file)
int | linphone_call_take_preview_snapshot (LinphoneCall *call, const char *file)
bool_t | linphone_call_camera_enabled (const LinphoneCall *call)
const char * | linphone_privacy_to_string (LinphonePrivacy privacy)
LinphoneAddress * | linphone_core_interpret_url (LinphoneCore *lc, const char *url)
LinphoneCall * | linphone_core_invite (LinphoneCore *lc, const char *url)
LinphoneCall * | linphone_core_invite_with_params (LinphoneCore *lc, const char *url, const LinphoneCallParams *p)
LinphoneCall * | linphone_core_invite_address (LinphoneCore *lc, const LinphoneAddress *addr)
LinphoneCall * | linphone_core_invite_address_with_params (LinphoneCore *lc, const LinphoneAddress *addr, const LinphoneCallParams *params)
int | linphone_core_transfer_call (LinphoneCore *lc, LinphoneCall *call, const char *url)
int | linphone_core_transfer_call_to_another (LinphoneCore *lc, LinphoneCall *call, LinphoneCall *dest)
int | linphone_core_accept_early_media_with_params (LinphoneCore *lc, LinphoneCall *call, const LinphoneCallParams *params)
int | linphone_core_accept_early_media (LinphoneCore *lc, LinphoneCall *call)
int | linphone_core_update_call (LinphoneCore *lc, LinphoneCall *call, const LinphoneCallParams *params)
int | linphone_core_defer_call_update (LinphoneCore *lc, LinphoneCall *call)
int | linphone_core_accept_call_update (LinphoneCore *lc, LinphoneCall *call, const LinphoneCallParams *params)
int | linphone_core_accept_call (LinphoneCore *lc, LinphoneCall *call)
int | linphone_core_accept_call_with_params (LinphoneCore *lc, LinphoneCall *call, const LinphoneCallParams *params)
int | linphone_core_terminate_call (LinphoneCore *lc, LinphoneCall *the_call)
int | linphone_core_decline_call (LinphoneCore *lc, LinphoneCall *call, LinphoneReason reason)
int | linphone_core_terminate_all_calls (LinphoneCore *lc)
const MSList * | linphone_core_get_calls (LinphoneCore *lc)
bool_t | linphone_core_in_call (const LinphoneCore *lc)
LinphoneCall * | linphone_core_get_current_call (const LinphoneCore *lc)
int | linphone_core_pause_call (LinphoneCore *lc, LinphoneCall *call)
int | linphone_core_pause_all_calls (LinphoneCore *lc)
int | linphone_core_resume_call (LinphoneCore *lc, LinphoneCall *call)
LinphoneCall * | linphone_core_get_call_by_remote_address (LinphoneCore *lc, const char *remote_address)
void | linphone_core_set_inc_timeout (LinphoneCore *lc, int seconds)
int | linphone_core_get_inc_timeout (LinphoneCore *lc)
void | linphone_core_set_in_call_timeout (LinphoneCore *lc, int seconds)
int | linphone_core_get_in_call_timeout (LinphoneCore *lc)
int | linphone_core_get_delayed_timeout (LinphoneCore *lc)
void | linphone_core_set_delayed_timeout (LinphoneCore *lc, int seconds)
int | linphone_core_get_calls_nb (const LinphoneCore *lc)
bool_t | linphone_core_can_we_add_call (LinphoneCore *lc)
LinphoneCallParams * | linphone_core_create_call_params (LinphoneCore *lc, LinphoneCall *call)
bool_t | linphone_core_sound_resources_locked (LinphoneCore *lc)
LinphoneCore * | linphone_call_get_core (const LinphoneCall *call)
const LinphoneAddress * | linphone_core_get_current_call_remote_address (LinphoneCore *lc)
bool_t | linphone_call_is_in_conference (const LinphoneCall *call)
bool_t | linphone_core_is_incoming_invite_pending (LinphoneCore *lc)
int | linphone_core_redirect_call (LinphoneCore *lc, LinphoneCall *call, const char *redirect_uri)
LinphoneCall * | linphone_core_find_call_from_uri (const LinphoneCore *lc, const char *uri)

## Detailed Description

The LinphoneCall object represents an incoming or outgoing call managed by the LinphoneCore. Outgoing calls can be created using linphone_core_invite() or linphone_core_invite_address(), while incoming calls are notified to the application through the LinphoneCoreVTable::call_state_changed callback.

See the basic call tutorial.

## Macro Definition Documentation

#define linphone_call_params_local_conference_mode linphone_call_params_get_local_conference_mode

Deprecated:
  Use linphone_call_params_get_local_conference_mode() instead.

## Typedef Documentation

typedef enum _LinphoneMediaDirection LinphoneMediaDirection

Typedef for enum

typedef struct _LinphoneCallParams LinphoneCallParams

The LinphoneCallParams is an object containing various call related parameters. It can be used to retrieve parameters from a currently running call or modify the call's characteristics dynamically.

typedef struct _LinphoneCall LinphoneCall

The LinphoneCall object represents a call issued or received by the LinphoneCore

typedef enum _LinphonePrivacy LinphonePrivacy

Defines privacy policy to apply as described by rfc3323

typedef struct _LinphonePlayer LinphonePlayer

Player interface.

typedef void(* LinphonePlayerEofCallback)(struct _LinphonePlayer *obj, void *user_data)

Callback for notifying end of play (file).

Parameters

  obj | the LinphonePlayer
  user_data | the user_data provided when calling linphone_player_open().

typedef enum _LinphoneCallState LinphoneCallState

LinphoneCallState enum represents the different state a call can reach into. The application is notified of state changes through the LinphoneCoreVTable::call_state_changed callback.

## Enumeration Type Documentation

enum _LinphoneMediaDirection

Indicates for a given media the stream direction

Enumerator
LinphoneMediaDirectionSendOnly | No active media not supported yet
LinphoneMediaDirectionRecvOnly | Send only mode
LinphoneMediaDirectionSendRecv | recv only mode

enum _LinphonePrivacy

Defines privacy policy to apply as described by rfc3323

Enumerator
LinphonePrivacyNone | Privacy services must not perform any privacy function
LinphonePrivacyUser | Request that privacy services provide a user-level privacy function. With this mode, "from" header is hidden, usually replaced by From: "Anonymous" <sip:anony.nosp@m.mous.nosp@m.@anon.nosp@m.ymou.nosp@m.s.inv.nosp@m.alid>
LinphonePrivacyHeader | Request that privacy services modify headers that cannot be set arbitrarily by the user (Contact/Via).
LinphonePrivacySession | Request that privacy services provide privacy for session media
LinphonePrivacyId | rfc3325 The presence of this privacy type in a Privacy header field indicates that the user would like the Network Asserted Identity to be kept private with respect to SIP entities outside the Trust Domain with which the user authenticated. Note that a user requesting multiple types of privacy MUST include all of the requested privacy types in its Privacy header field value
LinphonePrivacyCritical | Privacy service must perform the specified services or fail the request
LinphonePrivacyDefault | Special keyword to use privacy as defined either globally or by proxy using linphone_proxy_config_set_privacy()

enum _LinphoneCallState

LinphoneCallState enum represents the different state a call can reach into. The application is notified of state changes through the LinphoneCoreVTable::call_state_changed callback.

Enumerator
LinphoneCallIdle | Initial call state
LinphoneCallIncomingReceived | This is a new incoming call
LinphoneCallOutgoingInit | An outgoing call is started
LinphoneCallOutgoingProgress | An outgoing call is in progress
LinphoneCallOutgoingRinging | An outgoing call is ringing at remote end
LinphoneCallOutgoingEarlyMedia | An outgoing call is proposed early media
LinphoneCallConnected | Connected, the call is answered
LinphoneCallStreamsRunning | The media streams are established and running
LinphoneCallPausing | The call is pausing at the initiative of local end
LinphoneCallPaused | The call is paused, remote end has accepted the pause
LinphoneCallResuming | The call is being resumed by local end
LinphoneCallRefered | The call is being transfered to another party, resulting in a new outgoing call to follow immediately
LinphoneCallError | The call encountered an error
LinphoneCallEnd | The call ended normally
LinphoneCallPausedByRemote | The call is paused by remote end
LinphoneCallUpdatedByRemote | The call's parameters change is requested by remote end, used for example when video is added by remote
LinphoneCallIncomingEarlyMedia | We are proposing early media to an incoming call
LinphoneCallUpdating | A call update has been initiated by us
LinphoneCallReleased | The call object is no more retained by the core

## Function Documentation

void linphone_call_params_add_custom_header | ( | LinphoneCallParams * | cp,
|  | const char * | header_name,
|  | const char * | header_value
| ) |  |

Add a custom SIP header in the INVITE for a call.

Parameters

  [in] | cp | The LinphoneCallParams to add a custom SIP header to.
  [in] | header_name | The name of the header to add.
  [in] | header_value | The content of the header to add.

LinphoneCallParams* linphone_call_params_copy | ( | const LinphoneCallParams * | cp | ) |

Copy an existing LinphoneCallParams object to a new LinphoneCallParams object.

Parameters

  [in] | cp | The LinphoneCallParams object to copy.

Returns
  A copy of the LinphoneCallParams object.

bool_t linphone_call_params_early_media_sending_enabled | ( | const LinphoneCallParams * | cp | ) |

Indicate whether sending of early media was enabled.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  A boolean value telling whether sending of early media was enabled.

void linphone_call_params_enable_early_media_sending | ( | LinphoneCallParams * | cp,
|  | bool_t | enabled
| ) |  |

Enable sending of real early media (during outgoing calls).

Parameters

  [in] | cp | LinphoneCallParams object
  [in] | enabled | A boolean value telling whether to enable early media sending or not.

void linphone_call_params_enable_low_bandwidth | ( | LinphoneCallParams * | cp,
|  | bool_t | enabled
| ) |  |

Indicate low bandwith mode. Configuring a call to low bandwidth mode will result in the core to activate several settings for the call in order to ensure that bitrate usage is lowered to the minimum possible. Typically, ptime (packetization time) will be increased, audio codec's output bitrate will be targetted to 20kbit/s provided that it is achievable by the codec selected after SDP handshake. Video is automatically disabled.

Parameters

  [in] | cp | LinphoneCallParams object
  [in] | enabled | A boolean value telling whether to activate the low bandwidth mode or not.

void linphone_call_params_enable_video | ( | LinphoneCallParams * | cp,
|  | bool_t | enabled
| ) |  |

Enable video stream.

Parameters

  [in] | cp | LinphoneCallParams object
  [in] | enabled | A boolean value telling whether to enable video or not.

const char* linphone_call_params_get_custom_header | ( | const LinphoneCallParams * | cp,
|  | const char * | header_name
| ) |  |

Get a custom SIP header.

Parameters

  [in] | cp | The LinphoneCallParams to get the custom SIP header from.
  [in] | header_name | The name of the header to get.

Returns
  The content of the header or NULL if not found.

bool_t linphone_call_params_get_local_conference_mode | ( | const LinphoneCallParams * | cp | ) |

Tell whether the call is part of the locally managed conference.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  A boolean value telling whether the call is part of the locally managed conference.

LinphoneMediaEncryption linphone_call_params_get_media_encryption | ( | const LinphoneCallParams * | cp | ) |

Get the kind of media encryption selected for the call.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The kind of media encryption selected for the call.

LinphonePrivacyMask linphone_call_params_get_privacy | ( | const LinphoneCallParams * | cp | ) |

Get requested level of privacy for the call.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The privacy mode used for the call.

float linphone_call_params_get_received_framerate | ( | const LinphoneCallParams * | cp | ) |

Get the framerate of the video that is received.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The actual received framerate in frames per seconds, 0 if not available.

MSVideoSize linphone_call_params_get_received_video_size | ( | const LinphoneCallParams * | cp | ) |

Get the size of the video that is received.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The received video size or MS_VIDEO_SIZE_UNKNOWN if not available.

const char* linphone_call_params_get_record_file | ( | const LinphoneCallParams * | cp | ) |

Get the path for the audio recording of the call.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The path to the audio recording of the call.

const char* linphone_call_params_get_rtp_profile | ( | const LinphoneCallParams * | cp | ) |

Get the RTP profile being used.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The RTP profile.

float linphone_call_params_get_sent_framerate | ( | const LinphoneCallParams * | cp | ) |

Get the framerate of the video that is sent.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The actual sent framerate in frames per seconds, 0 if not available.

MSVideoSize linphone_call_params_get_sent_video_size | ( | const LinphoneCallParams * | cp | ) |

Gets the size of the video that is sent.

Parameters

  [in] | cp | LinphoneCalParams object

Returns
  The sent video size or MS_VIDEO_SIZE_UNKNOWN if not available.

const char* linphone_call_params_get_session_name | ( | const LinphoneCallParams * | cp | ) |

Get the session name of the media session (ie in SDP). Subject from the SIP message can be retrieved using linphone_call_params_get_custom_header() and is different.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The session name of the media session.

const LinphonePayloadType* linphone_call_params_get_used_audio_codec | ( | const LinphoneCallParams * | cp | ) |

Get the audio codec used in the call, described as a LinphonePayloadType object.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The LinphonePayloadType object corresponding to the audio codec being used in the call.

const LinphonePayloadType* linphone_call_params_get_used_video_codec | ( | const LinphoneCallParams * | cp | ) |

Get the video codec used in the call, described as a LinphonePayloadType structure.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  The LinphonePayloadType object corresponding to the video codec being used in the call.

bool_t linphone_call_params_low_bandwidth_enabled | ( | const LinphoneCallParams * | cp | ) |

Tell whether the call has been configured in low bandwidth mode or not. This mode can be automatically discovered thanks to a stun server when activate_edge_workarounds=1 in section [net] of configuration file. An application that would have reliable way to know network capacity may not use activate_edge_workarounds=1 but instead manually configure low bandwidth mode with linphone_call_params_enable_low_bandwidth(). When enabled, this param may transform a call request with video in audio only mode.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  A boolean value telling whether the low bandwidth mode has been configured/detected.

void linphone_call_params_set_audio_bandwidth_limit | ( | LinphoneCallParams * | cp,
|  | int | bw
| ) |  |

Refine bandwidth settings for this call by setting a bandwidth limit for audio streams. As a consequence, codecs whose bitrates are not compatible with this limit won't be used.

Parameters

  [in] | cp | LinphoneCallParams object
  [in] | bw | The audio bandwidth limit to set in kbit/s.

void linphone_call_params_set_media_encryption | ( | LinphoneCallParams * | cp,
|  | LinphoneMediaEncryption | enc
| ) |  |

Set requested media encryption for a call.

Parameters

  [in] | cp | LinphoneCallParams object
  [in] | enc | The media encryption to use for the call.

void linphone_call_params_set_privacy | ( | LinphoneCallParams * | params,
|  | LinphonePrivacyMask | privacy
| ) |  |

Set requested level of privacy for the call.

Parameters

  [in] | cp | LinphoneCallParams object
  [in] | privacy | The privacy mode to used for the call.

void linphone_call_params_set_record_file | ( | LinphoneCallParams * | cp,
|  | const char * | path
| ) |  |

Enable recording of the call. This function must be used before the call parameters are assigned to the call. The call recording can be started and paused after the call is established with linphone_call_start_recording() and linphone_call_pause_recording().

Parameters

  [in] | cp | LinphoneCallParams object
  [in] | path | A string containing the path and filename of the file where audio/video streams are to be written. The filename must have either .mkv or .wav extention. The video stream will be written only if a MKV file is given.

void linphone_call_params_set_session_name | ( | LinphoneCallParams * | cp,
|  | const char * | name
| ) |  |

Set the session name of the media session (ie in SDP). Subject from the SIP message (which is different) can be set using linphone_call_params_set_custom_header().

Parameters

  [in] | cp | LinphoneCallParams object
  [in] | name | The session name to be used.

bool_t linphone_call_params_video_enabled | ( | const LinphoneCallParams * | cp | ) |

Tell whether video is enabled or not.

Parameters

  [in] | cp | LinphoneCallParams object

Returns
  A boolean value telling whether video is enabled or not.

LinphoneMediaDirection linphone_call_params_get_audio_direction | ( | const LinphoneCallParams * | cp | ) |

Get the audio stream direction.

Parameters

  [in] | cl | LinphoneCallParams object

Returns
  The audio stream direction associated with the call params.

LinphoneMediaDirection linphone_call_params_get_video_direction | ( | const LinphoneCallParams * | cp | ) |

Get the video stream direction.

Parameters

  [in] | cl | LinphoneCallParams object

Returns
  The video stream direction associated with the call params.

void linphone_call_params_set_audio_direction | ( | LinphoneCallParams * | cp,
|  | LinphoneMediaDirection | dir
| ) |  |

Set the audio stream direction. Only relevant for multicast

Parameters

  [in] | cl | LinphoneCallParams object
  [in] | The | audio stream direction associated with this call params.

void linphone_call_params_set_video_direction | ( | LinphoneCallParams * | cp,
|  | LinphoneMediaDirection | dir
| ) |  |

Set the video stream direction. Only relevant for multicast

Parameters

  [in] | cl | LinphoneCallParams object
  [in] | The | video stream direction associated with this call params.

void* linphone_call_params_get_user_data | ( | const LinphoneCallParams * | cp | ) |

Get the user data associated with the call params.

Parameters

  [in] | cl | LinphoneCallParams object

Returns
  The user data associated with the call params.

void linphone_call_params_set_user_data | ( | LinphoneCallParams * | cp,
|  | void * | ud
| ) |  |

Assign a user data to the call params.

Parameters

  [in] | cl | LinphoneCallParams object
  [in] | ud | The user data to associate with the call params.

LinphoneCallParams* linphone_call_params_ref | ( | LinphoneCallParams * | cp | ) |

Acquire a reference to the call params.

Parameters

  [in] | cl | LinphoneCallParams object

Returns
  The same LinphoneCallParams object

void linphone_call_params_unref | ( | LinphoneCallParams * | cp | ) |

Release a reference to the call params.

Parameters

  [in] | cl | LinphoneCallParams object

void linphone_call_params_destroy | ( | LinphoneCallParams * | cp | ) |

Destroy a LinphoneCallParams object.

Parameters

  [in] | cp | LinphoneCallParams object

Deprecated:
  Use linphone_call_params_unref() instead.

bool_t linphone_call_get_authentication_token_verified | ( | LinphoneCall * | call | ) |

Returns whether ZRTP authentication token is verified. If not, it must be verified by users as described in ZRTP procedure. Once done, the application must inform of the results with linphone_call_set_authentication_token_verified().

Parameters

  call | the LinphoneCall

Returns
  TRUE if authentication token is verifed, false otherwise.

void linphone_call_set_authentication_token_verified | ( | LinphoneCall * | call,
|  | bool_t | verified
| ) |  |

Set the result of ZRTP short code verification by user. If remote party also does the same, it will update the ZRTP cache so that user's verification will not be required for the two users.

Parameters

  call | the LinphoneCall
  verified | whether the ZRTP SAS is verified.

LinphoneCall * linphone_call_ref | ( | LinphoneCall * | call | ) |

Acquire a reference to the call. An application that wishes to retain a pointer to call object must use this function to unsure the pointer remains valid. Once the application no more needs this pointer, it must call linphone_call_unref().

Parameters

  [in] | call | The call.

Returns
  The same call.

void linphone_call_unref | ( | LinphoneCall * | call | ) |

Release reference to the call.

Parameters

  [in] | call | The call.

const LinphoneCallParams* linphone_call_get_current_params | ( | LinphoneCall * | call | ) |

Returns current parameters associated to the call.

const LinphoneCallParams* linphone_call_get_remote_params | ( | LinphoneCall * | call | ) |

Returns call parameters proposed by remote.

This is useful when receiving an incoming call, to know whether the remote party supports video, encryption or whatever.

const LinphoneAddress* linphone_call_get_remote_address | ( | const LinphoneCall * | call | ) |

Returns the remote address associated to this call

char* linphone_call_get_remote_address_as_string | ( | const LinphoneCall * | call | ) |

Returns the remote address associated to this call as a string.

The result string must be freed by user using ms_free().

LinphoneCallState linphone_call_get_state | ( | const LinphoneCall * | call | ) |

Retrieves the call's current state.

LinphoneReason linphone_call_get_reason | ( | const LinphoneCall * | call | ) |

Returns the reason for a call termination (either error or normal termination)

const LinphoneErrorInfo* linphone_call_get_error_info | ( | const LinphoneCall * | call | ) |

Returns full details about call errors or termination reasons.

void * linphone_call_get_user_data | ( | const LinphoneCall * | call | ) |

Get the user pointer associated with the LinphoneCall

Returns
  an opaque user pointer that can be retrieved at any time

Retrieve the user pointer associated with the call.

Parameters

  [in] | call | The call.

Returns
  The user pointer associated with the call.

void linphone_call_set_user_data | ( | LinphoneCall * | call,
|  | void * | user_pointer
| ) |  |

Set the user pointer associated with the LinphoneCall

the user pointer is an opaque user pointer that can be retrieved at any time in the LinphoneCall

Assign a user pointer to the call.

Parameters

  [in] | cfg | The call.
  [in] | ud | The user pointer to associate with the call.

LinphoneCallLog* linphone_call_get_call_log | ( | const LinphoneCall * | call | ) |

Returns the call log associated to this call.

const char* linphone_call_get_refer_to | ( | const LinphoneCall * | call | ) |

Returns the refer-to uri (if the call was transfered).

LinphoneCall* linphone_call_get_transferer_call | ( | const LinphoneCall * | call | ) |

Returns the transferer if this call was started automatically as a result of an incoming transfer request. The call in which the transfer request was received is returned in this case.

LinphoneCall* linphone_call_get_transfer_target_call | ( | const LinphoneCall * | call | ) |

When this call has received a transfer request, returns the new call that was automatically created as a result of the transfer.

LinphoneCallDir linphone_call_get_dir | ( | const LinphoneCall * | call | ) |

Returns direction of the call (incoming or outgoing).

const char* linphone_call_get_remote_user_agent | ( | LinphoneCall * | call | ) |

Returns the far end's user agent description string, if available.

const char* linphone_call_get_remote_contact | ( | LinphoneCall * | call | ) |

Returns the far end's sip contact as a string, if available.

bool_t linphone_call_has_transfer_pending | ( | const LinphoneCall * | call | ) |

Returns true if this calls has received a transfer that has not been executed yet. Pending transfers are executed when this call is being paused or closed, locally or by remote endpoint. If the call is already paused while receiving the transfer request, the transfer immediately occurs.

int linphone_call_get_duration | ( | const LinphoneCall * | call | ) |

Returns call's duration in seconds.

LinphoneCall* linphone_call_get_replaced_call | ( | LinphoneCall * | call | ) |

Returns the call object this call is replacing, if any. Call replacement can occur during call transfers. By default, the core automatically terminates the replaced call and accept the new one. This function allows the application to know whether a new incoming call is a one that replaces another one.

void linphone_call_enable_camera | ( | LinphoneCall * | call,
|  | bool_t | enable
| ) |  |

Indicate whether camera input should be sent to remote end.

void linphone_call_send_vfu_request | ( | LinphoneCall * | call | ) |

Request remote side to send us a Video Fast Update.

int linphone_call_take_video_snapshot | ( | LinphoneCall * | call,
|  | const char * | file
| ) |  |

Take a photo of currently received video and write it into a jpeg file. Note that the snapshot is asynchronous, an application shall not assume that the file is created when the function returns.

Parameters

  call | a LinphoneCall
  file | a path where to write the jpeg content.

Returns
  0 if successfull, -1 otherwise (typically if jpeg format is not supported).

int linphone_call_take_preview_snapshot | ( | LinphoneCall * | call,
|  | const char * | file
| ) |  |

Take a photo of currently captured video and write it into a jpeg file. Note that the snapshot is asynchronous, an application shall not assume that the file is created when the function returns.

Parameters

  call | a LinphoneCall
  file | a path where to write the jpeg content.

Returns
  0 if successfull, -1 otherwise (typically if jpeg format is not supported).

bool_t linphone_call_camera_enabled | ( | const LinphoneCall * | call | ) |

Returns TRUE if camera pictures are allowed to be sent to the remote party.

const char* linphone_privacy_to_string | ( | LinphonePrivacy | privacy | ) |

Returns
  string value of LinphonePrivacy enum

LinphoneAddress* linphone_core_interpret_url | ( | LinphoneCore * | lc,
|  | const char * | url
| ) |  |

Interpret a call destination as supplied by the user, and returns a fully qualified LinphoneAddress.

A sip address should look like DisplayName <sip:username@domain:port> . Basically this function performs the following tasks

- if a phone number is entered, prepend country prefix of the default proxy configuration, eventually escape the '+' by 00.
- if no domain part is supplied, append the domain name of the default proxy
- if no sip: is present, prepend it

The result is a syntaxically correct SIP address.

LinphoneCall* linphone_core_invite | ( | LinphoneCore * | lc,
|  | const char * | url
| ) |  |

Initiates an outgoing call

Parameters

  lc | the LinphoneCore object
  url | the destination of the call (sip address, or phone number).

The application doesn't own a reference to the returned LinphoneCall object. Use linphone_call_ref() to safely keep the LinphoneCall pointer valid within your application.

Returns
  a LinphoneCall object or NULL in case of failure

LinphoneCall* linphone_core_invite_with_params | ( | LinphoneCore * | lc,
|  | const char * | url,
|  | const LinphoneCallParams * | p
| ) |  |

Initiates an outgoing call according to supplied call parameters

Parameters

  lc | the LinphoneCore object
  url | the destination of the call (sip address, or phone number).
  p | call parameters

The application doesn't own a reference to the returned LinphoneCall object. Use linphone_call_ref() to safely keep the LinphoneCall pointer valid within your application.

Returns
  a LinphoneCall object or NULL in case of failure

LinphoneCall* linphone_core_invite_address | ( | LinphoneCore * | lc,
|  | const LinphoneAddress * | addr
| ) |  |

Initiates an outgoing call given a destination LinphoneAddress

Parameters

  lc | the LinphoneCore object
  addr | the destination of the call (sip address).

The LinphoneAddress can be constructed directly using linphone_address_new(), or created by linphone_core_interpret_url(). The application doesn't own a reference to the returned LinphoneCall object. Use linphone_call_ref() to safely keep the LinphoneCall pointer valid within your application.

Returns
  a LinphoneCall object or NULL in case of failure

LinphoneCall* linphone_core_invite_address_with_params | ( | LinphoneCore * | lc,
|  | const LinphoneAddress * | addr,
|  | const LinphoneCallParams * | params
| ) |  |

Initiates an outgoing call given a destination LinphoneAddress

Parameters

  lc | the LinphoneCore object
  addr | the destination of the call (sip address).
  params | call parameters

The LinphoneAddress can be constructed directly using linphone_address_new(), or created by linphone_core_interpret_url(). The application doesn't own a reference to the returned LinphoneCall object. Use linphone_call_ref() to safely keep the LinphoneCall pointer valid within your application.

Returns
  a LinphoneCall object or NULL in case of failure

int linphone_core_transfer_call | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call,
|  | const char * | url
| ) |  |

Performs a simple call transfer to the specified destination.

The remote endpoint is expected to issue a new call to the specified destination. The current call remains active and thus can be later paused or terminated.

It is possible to follow the progress of the transfer provided that transferee sends notification about it. In this case, the transfer_state_changed callback of the LinphoneCoreVTable is invoked to notify of the state of the new call at the other party. The notified states are LinphoneCallOutgoingInit , LinphoneCallOutgoingProgress, LinphoneCallOutgoingRinging and LinphoneCallConnected.

int linphone_core_transfer_call_to_another | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call,
|  | LinphoneCall * | dest
| ) |  |

Transfer a call to destination of another running call. This is used for "attended transfer" scenarios.

Parameters

  lc | linphone core object
  call | a running call you want to transfer
  dest | a running call whose remote person will receive the transfer

The transfered call is supposed to be in paused state, so that it is able to accept the transfer immediately. The destination call is a call previously established to introduce the transfered person. This method will send a transfer request to the transfered person. The phone of the transfered is then expected to automatically call to the destination of the transfer. The receiver of the transfer will then automatically close the call with us (the 'dest' call).

It is possible to follow the progress of the transfer provided that transferee sends notification about it. In this case, the transfer_state_changed callback of the LinphoneCoreVTable is invoked to notify of the state of the new call at the other party. The notified states are LinphoneCallOutgoingInit , LinphoneCallOutgoingProgress, LinphoneCallOutgoingRinging and LinphoneCallConnected.

int linphone_core_accept_early_media_with_params | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call,
|  | const LinphoneCallParams * | params
| ) |  |

When receiving an incoming, accept to start a media session as early-media. This means the call is not accepted but audio & video streams can be established if the remote party supports early media. However, unlike after call acceptance, mic and camera input are not sent during early-media, though received audio & video are played normally. The call can then later be fully accepted using linphone_core_accept_call() or linphone_core_accept_call_with_params().

Parameters

  lc | the linphonecore
  call | the call
  params | the call params, can be NULL.

Returns
  0 if successful, -1 otherwise.

int linphone_core_accept_early_media | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call
| ) |  |

Accept an early media session for an incoming call. This is identical as calling linphone_core_accept_early_media_with_params() with NULL call parameters.

See also
  linphone_core_accept_early_media_with_params()

Parameters

  lc | the core
  call | the incoming call

Returns
  0 if successful, -1 otherwise.

int linphone_core_update_call | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call,
|  | const LinphoneCallParams * | params
| ) |  |

Updates a running call according to supplied call parameters or parameters changed in the LinphoneCore.

In this version this is limited to the following use cases:

- setting up/down the video stream according to the video parameter of the LinphoneCallParams (see linphone_call_params_enable_video() ).
- changing the size of the transmitted video after calling linphone_core_set_preferred_video_size()

In case no changes are requested through the LinphoneCallParams argument, then this argument can be omitted and set to NULL.

Parameters

  lc | the core
  call | the call to be updated
  params | the new call parameters to use. (may be NULL)

Returns
  0 if successful, -1 otherwise.

int linphone_core_defer_call_update | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call
| ) |  |

When receiving a LinphoneCallUpdatedByRemote state notification, prevent LinphoneCore from performing an automatic answer.

When receiving a LinphoneCallUpdatedByRemote state notification (ie an incoming reINVITE), the default behaviour of LinphoneCore is to automatically answer the reINIVTE with call parameters unchanged. However when for example when the remote party updated the call to propose a video stream, it can be useful to prompt the user before answering. This can be achieved by calling linphone_core_defer_call_update() during the call state notifiacation, to deactivate the automatic answer that would just confirm the audio but reject the video. Then, when the user responds to dialog prompt, it becomes possible to call linphone_core_accept_call_update() to answer the reINVITE, with eventually video enabled in the LinphoneCallParams argument.

Returns
  0 if successful, -1 if the linphone_core_defer_call_update() was done outside a LinphoneCallUpdatedByRemote notification, which is illegal.

int linphone_core_accept_call_update | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call,
|  | const LinphoneCallParams * | params
| ) |  |

Accept call modifications initiated by other end.

This call may be performed in response to a LinphoneCallUpdatedByRemote state notification. When such notification arrives, the application can decide to call linphone_core_defer_update_call() so that it can have the time to prompt the user. linphone_call_get_remote_params() can be used to get information about the call parameters requested by the other party, such as whether a video stream is requested.

When the user accepts or refuse the change, linphone_core_accept_call_update() can be done to answer to the other party. If params is NULL, then the same call parameters established before the update request will continue to be used (no change). If params is not NULL, then the update will be accepted according to the parameters passed. Typical example is when a user accepts to start video, then params should indicate that video stream should be used (see linphone_call_params_enable_video()).

Parameters

  lc | the linphone core object.
  call | the LinphoneCall object
  params | a LinphoneCallParams object describing the call parameters to accept.

Returns
  0 if successful, -1 otherwise (actually when this function call is performed outside ot LinphoneCallUpdatedByRemote state).

int linphone_core_accept_call | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call
| ) |  |

Accept an incoming call.

Basically the application is notified of incoming calls within the call_state_changed callback of the LinphoneCoreVTable structure, where it will receive a LinphoneCallIncoming event with the associated LinphoneCall object. The application can later accept the call using this method.

Parameters

  lc | the LinphoneCore object
  call | the LinphoneCall object representing the call to be answered.

int linphone_core_accept_call_with_params | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call,
|  | const LinphoneCallParams * | params
| ) |  |

Accept an incoming call, with parameters.

Basically the application is notified of incoming calls within the call_state_changed callback of the LinphoneCoreVTable structure, where it will receive a LinphoneCallIncoming event with the associated LinphoneCall object. The application can later accept the call using this method.

Parameters

  lc | the LinphoneCore object
  call | the LinphoneCall object representing the call to be answered.
  params | the specific parameters for this call, for example whether video is accepted or not. Use NULL to use default parameters.

int linphone_core_terminate_call | ( | LinphoneCore * | lc,
|  | LinphoneCall * | the_call
| ) |  |

Terminates a call.

Parameters

  lc | the LinphoneCore
  the_call | the LinphoneCall object representing the call to be terminated.

int linphone_core_decline_call | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call,
|  | LinphoneReason | reason
| ) |  |

Decline a pending incoming call, with a reason.

Parameters

  lc | the linphone core
  call | the LinphoneCall, must be in the IncomingReceived state.
  reason | the reason for rejecting the call: LinphoneReasonDeclined or LinphoneReasonBusy

int linphone_core_terminate_all_calls | ( | LinphoneCore * | lc | ) |

Terminates all the calls.

Parameters

  lc | The LinphoneCore

const MSList* linphone_core_get_calls | ( | LinphoneCore * | lc | ) |

Returns the current list of calls.

Parameters

  [in] | lc | The LinphoneCore object

Returns
  A list of LinphoneCall objects.

Note that this list is read-only and might be changed by the core after a function call to linphone_core_iterate(). Similarly the LinphoneCall objects inside it might be destroyed without prior notice. To hold references to LinphoneCall object into your program, you must use linphone_call_ref().

bool_t linphone_core_in_call | ( | const LinphoneCore * | lc | ) |

Returns TRUE if there is a call running.

LinphoneCall* linphone_core_get_current_call | ( | const LinphoneCore * | lc | ) |

Returns The _LinphoneCall struct of the current call if one is in call

int linphone_core_pause_call | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call
| ) |  |

Pauses the call. If a music file has been setup using linphone_core_set_play_file(), this file will be played to the remote user.

int linphone_core_pause_all_calls | ( | LinphoneCore * | lc | ) |

Pause all currently running calls.

int linphone_core_resume_call | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call
| ) |  |

Resumes the call.

LinphoneCall* linphone_core_get_call_by_remote_address | ( | LinphoneCore * | lc,
|  | const char * | remote_address
| ) |  |

Get the call with the remote_address specified

Parameters

  lc |
  remote_address |

Returns
  the LinphoneCall of the call if found

void linphone_core_set_inc_timeout | ( | LinphoneCore * | lc,
|  | int | seconds
| ) |  |

Set the incoming call timeout in seconds.

If an incoming call isn't answered for this timeout period, it is automatically declined.

int linphone_core_get_inc_timeout | ( | LinphoneCore * | lc | ) |

Returns the incoming call timeout

See linphone_core_set_inc_timeout() for details.

void linphone_core_set_in_call_timeout | ( | LinphoneCore * | lc,
|  | int | seconds
| ) |  |

Set the in call timeout in seconds.

After this timeout period, the call is automatically hangup.

int linphone_core_get_in_call_timeout | ( | LinphoneCore * | lc | ) |

Returns the in call timeout

See linphone_core_set_in_call_timeout() for details.

int linphone_core_get_delayed_timeout | ( | LinphoneCore * | lc | ) |

Returns the delayed timeout

See linphone_core_set_delayed_timeout() for details.

void linphone_core_set_delayed_timeout | ( | LinphoneCore * | lc,
|  | int | seconds
| ) |  |

Set the in delayed timeout in seconds.

After this timeout period, a delayed call (internal call initialisation or resolution) is resumed.

int linphone_core_get_calls_nb | ( | const LinphoneCore * | lc | ) |

Get the number of Call

bool_t linphone_core_can_we_add_call | ( | LinphoneCore * | lc | ) |

Check if we do not have exceed the number of simultaneous call

LinphoneCallParams* linphone_core_create_call_params | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call
| ) |  |

Create a LinphoneCallParams suitable for linphone_core_invite_with_params(), linphone_core_accept_call_with_params(), linphone_core_accept_early_media_with_params(), linphone_core_accept_call_update(). The parameters are initialized according to the current LinphoneCore configuration and the current state of the LinphoneCall.

Parameters

  lc | the LinphoneCore
  call | the call for which the parameters are to be build, or NULL in the case where the parameters are to be used for a new outgoing call.

Returns
  a new LinphoneCallParams

bool_t linphone_core_sound_resources_locked | ( | LinphoneCore * | lc | ) |

Check if a call will need the sound resources.

Parameters

  lc | The LinphoneCore

LinphoneCore* linphone_call_get_core | ( | const LinphoneCall * | call | ) |

Get the core that has created the specified call.

Parameters

  [in] | call | LinphoneCall object

Returns
  The LinphoneCore object that has created the specified call.

const LinphoneAddress* linphone_core_get_current_call_remote_address | ( | LinphoneCore * | lc | ) |

Get the remote address of the current call.

Parameters

  [in] | lc | LinphoneCore object.

Returns
  The remote address of the current call or NULL if there is no current call.

bool_t linphone_call_is_in_conference | ( | const LinphoneCall * | call | ) |

Return TRUE if this call is currently part of a conference

Parameters

  call | LinphoneCall

Returns
  TRUE if part of a conference.

Deprecated:

bool_t linphone_core_is_incoming_invite_pending | ( | LinphoneCore * | lc | ) |

Tells whether there is an incoming invite pending.

Parameters

  [in] | lc | LinphoneCore object

Returns
  A boolean telling whether an incoming invite is pending or not.

int linphone_core_redirect_call | ( | LinphoneCore * | lc,
|  | LinphoneCall * | call,
|  | const char * | redirect_uri
| ) |  |

Redirect the specified call to the given redirect URI.

Parameters

  [in] | lc | LinphoneCore object.
  [in] | call | The LinphoneCall to redirect.
  [in] | redirect_uri | The URI to redirect the call to.

Returns
  0 if successful, -1 on error.

LinphoneCall* linphone_core_find_call_from_uri | ( | const LinphoneCore * | lc,
|  | const char * | uri
| ) |  |

Search from the list of current calls if a remote address match uri

Parameters

  lc |
  uri | which should match call remote uri

Returns
  LinphoneCall or NULL is no match is found